scraper = {}

function scraper.prerequisitesPresent(specializations)
     Vehicle.registerJointType("shovel");
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function scraper:load(xmlFile)

    local rotationPartNodetourelle = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle#index"));
    if rotationPartNodetourelle ~= nil then
        self.tourelle = {};
        self.tourelle.node = rotationPartNodetourelle;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle#minRot"));
        self.tourelle.minRot = {};
        self.tourelle.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle#maxRot"));
        self.tourelle.maxRot = {};
        self.tourelle.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tourelle.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle#rotTime"), 2)*1000;
        self.tourelle.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle#touchRotLimit"), 10))
    end;
    local rotationPartNodetourelle2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle2#index"));
    if rotationPartNodetourelle2 ~= nil then
        self.tourelle2 = {};
        self.tourelle2.node = rotationPartNodetourelle2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle2#minRot"));
        self.tourelle2.minRot = {};
        self.tourelle2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle2#maxRot"));
        self.tourelle2.maxRot = {};
        self.tourelle2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tourelle2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle2#rotTime"), 2)*1000;
        self.tourelle2.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle2#pivotverin"));
    end;
    local rotationPartNodetourelle3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle3#index"));
    if rotationPartNodetourelle3 ~= nil then
        self.tourelle3 = {};
        self.tourelle3.node = rotationPartNodetourelle3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle3#minRot"));
        self.tourelle3.minRot = {};
        self.tourelle3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle3#maxRot"));
        self.tourelle3.maxRot = {};
        self.tourelle3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tourelle3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle3#rotTime"), 2)*1000;
        self.tourelle3.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle3#pivotverin"));
    end;
    local rotationPartNodetourelle4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle4#index"));
    if rotationPartNodetourelle4 ~= nil then
        self.tourelle4 = {};
        self.tourelle4.node = rotationPartNodetourelle4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle4#minRot"));
        self.tourelle4.minRot = {};
        self.tourelle4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle4#maxRot"));
        self.tourelle4.maxRot = {};
        self.tourelle4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tourelle4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle4#rotTime"), 2)*1000;
        self.tourelle4.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle4#pivotverin"));
    end;

    local rotationPartNodebras1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras1#index"));
    if rotationPartNodebras1 ~= nil then
        self.bras1 = {};
        self.bras1.node = rotationPartNodebras1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras1#minRot"));
        self.bras1.minRot = {};
        self.bras1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras1#maxRot"));
        self.bras1.maxRot = {};
        self.bras1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras1#rotTime"), 2)*1000;

        self.bras1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras1#touchRotLimit"), 10))

    end;
    local rotationPartNodebras2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#index"));
    if rotationPartNodebras2 ~= nil then
        self.bras2 = {};
        self.bras2.node = rotationPartNodebras2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras2#minRot"));
        self.bras2.minRot = {};
        self.bras2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras2#maxRot"));
        self.bras2.maxRot = {};
        self.bras2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras2#rotTime"), 2)*1000;
        self.bras2.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#pivotverin"));
        self.bras2.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#pivotverin2"));

    end;
    
    
    self.verin1 = {};
	self.verin1.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indexverin"));

	self.verin2 = {};
	self.verin2.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indexverin"));
	
	self.verin6 = {};
	self.verin6.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin6#indexverin"));
	self.verin6.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin6#pivotverin"));
	
	self.verin7 = {};
	self.verin7.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin7#indexverin"));
	self.verin7.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin7#pivotverin"));
	self.verin7.pivotverin2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin7#pivotverin2"));
	
	self.verin8 = {};
	self.verin8.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin8#indexverin"));
	
	self.verin3 = {};
	self.verin3.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin3#indexverin"));
	self.verin3.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin3#indextige"));
	self.verin3.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin3#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin3.tige);
    local bx, by, bz = getWorldTranslation(self.verin3.translationtige);
    self.verin3.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

    self.verin4 = {};
	self.verin4.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin4#indexverin"));
	self.verin4.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin4#indextige"));
	self.verin4.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin4#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin4.tige);
    local bx, by, bz = getWorldTranslation(self.verin4.translationtige);
    self.verin4.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    self.verin5 = {};
	self.verin5.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin5#indexverin"));
	self.verin5.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin5#indextige"));
	self.verin5.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin5#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin5.tige);
    local bx, by, bz = getWorldTranslation(self.verin5.translationtige);
    self.verin5.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    self.verin9 = {};
	self.verin9.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin9#indexverin"));
	self.verin9.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin9#indextige"));
	self.verin9.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin9#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin9.tige);
    local bx, by, bz = getWorldTranslation(self.verin9.translationtige);
    self.verin9.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

     self.translationMax = true;
     self.translationMax2 = true;
     
    local numexhaustParticleSystems = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystems#count"), 0);
    self.exhaustParticleSystems = {};
    for i=1, numexhaustParticleSystems do
        local namei = string.format("vehicle.exhaustParticleSystems.exhaustParticle%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems, namei, nodei, false, nil, self.baseDirectory)
        setVisibility(self.exhaustParticleSystems[i], false);
    end;

    local numexhaustParticleSystem = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystem#count"), 0);
    self.exhaustParticleSystem = {};
    for i=1, numexhaustParticleSystem do
        local namei = string.format("vehicle.exhaustParticleSystem.exhaustParticle%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystem, namei, nodei, false, nil, self.baseDirectory)
        setVisibility(self.exhaustParticleSystem[i], false);
    end;

    local numexhaustParticleSyste = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSyste#count"), 0);
    self.exhaustParticleSyste = {};
    for i=1, numexhaustParticleSyste do
        local namei = string.format("vehicle.exhaustParticleSyste.exhaustParticle%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSyste, namei, nodei, false, nil, self.baseDirectory)
        setVisibility(self.exhaustParticleSyste[i], false);
    end;
    
    local numexhaustParticleSyst = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSyst#count"), 0);
    self.exhaustParticleSyst = {};
    for i=1, numexhaustParticleSyst do
        local namei = string.format("vehicle.exhaustParticleSyst.exhaustParticle%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSyst, namei, nodei, false, nil, self.baseDirectory)
        setVisibility(self.exhaustParticleSyst[i], false);
    end;
     
     
end;

function scraper:delete()

end;


function scraper:mouseEvent(posX, posY, isDown, isUp, button)
end;

function scraper:keyEvent(unicode, sym, modifier, isDown)
	if self.isEntered and self.isMotorStarted then
    
		if sym == Input.KEY_a then
			self.rotationMintourelle = isDown;
			self.rotationMintourelle2 = isDown;
			self.rotationMintourelle3 = isDown;
    	end;


        if sym == Input.KEY_d then
			self.rotationMaxtourelle = isDown;
			self.rotationMaxtourelle2 = isDown;
			self.rotationMaxtourelle3 = isDown;
        end;

		if sym == Input.KEY_KP_7 then
			self.rotationMintourelle4 = isDown;
			
    	end;

        if sym == Input.KEY_KP_4 then
			self.rotationMaxtourelle4 = isDown;
        end;


    end;
end;


function scraper:update(dt)








        if self: getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
			self.translationMax2 = not self.translationMax2;
			
		end;
        end;
	
        if self: getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
			self.translationMax = not self.translationMax;

		end;
        end;

	
	   	for i, jointDesc in pairs(self.componentJoints) do
	   setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;
	
    local doRotate = self.rotationMaxtourelle or self.rotationMintourelle
    if self.tourelle ~= nil and doRotate then
		local x, y, z = getRotation(self.tourelle.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.tourelle.maxRot, self.tourelle.minRot, 3, self.tourelle.rotTime, dt, not self.rotationMaxtourelle);
		setRotation(self.tourelle.node, unpack(newRot));
	end;
	local doRotate = self.rotationMaxtourelle2 or self.rotationMintourelle2
    if self.tourelle2 ~= nil and doRotate then
		local x, y, z = getRotation(self.tourelle2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.tourelle2.maxRot, self.tourelle2.minRot, 3, self.tourelle2.rotTime, dt, not self.rotationMaxtourelle2);
		setRotation(self.tourelle2.node, unpack(newRot));
	end;
	local doRotate = self.rotationMaxtourelle3 or self.rotationMintourelle3
    if self.tourelle3 ~= nil and doRotate then
		local x, y, z = getRotation(self.tourelle3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.tourelle3.maxRot, self.tourelle3.minRot, 3, self.tourelle3.rotTime, dt, not self.rotationMaxtourelle3);
		setRotation(self.tourelle3.node, unpack(newRot));
	end;
	local doRotate = self.rotationMaxtourelle4 or self.rotationMintourelle4
    if self.tourelle4 ~= nil and doRotate then
		local x, y, z = getRotation(self.tourelle4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.tourelle4.maxRot, self.tourelle4.minRot, 3, self.tourelle4.rotTime, dt, not self.rotationMaxtourelle4);
		setRotation(self.tourelle4.node, unpack(newRot));
	end;
	
	if self.translationMax2 ~= nil then
		local x, y, z = getRotation(self.bras1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras1.maxRot, self.bras1.minRot, 3, self.bras1.rotTime, dt, not self.translationMax2);
		setRotation(self.bras1.node, unpack(newRot));
	end;
	if self.translationMax2 ~= nil then
		local x, y, z = getRotation(self.bras2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras2.maxRot, self.bras2.minRot, 3, self.bras2.rotTime, dt, not self.translationMax2);
		setRotation(self.bras2.node, unpack(newRot));
	end;
	
	
	local doRotate = self.rotationMaxbras2 or self.rotationMinbras2
    	if self.bras2 ~= nil and doRotate then
		local x, y, z = getRotation(self.bras2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras2.maxRot, self.bras2.minRot, 3, self.bras2.rotTime, dt, not self.rotationMaxbras2);
		setRotation(self.bras2.node, unpack(newRot));
	end;
	
	


	if self.verin1 ~= nil and self.tourelle2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin1.node);
		local bx, by, bz = getWorldTranslation(self.tourelle2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin1.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin1.node, x*-1, y*-1, z*-1, 0, 1, 0);
	end;
	if self.verin2 ~= nil and self.tourelle3 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin2.node);
		local bx, by, bz = getWorldTranslation(self.tourelle3.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin2.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin2.node, x*-1, y*-1, z*-1, 0, 1, 0);
	end;
	if self.verin6 ~= nil and self.bras2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin6.node);
		local bx, by, bz = getWorldTranslation(self.bras2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin6.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin6.node, x*-1, y*-1, z*-1, 0, 1, 0);
	end;
	if self.verin7 ~= nil and self.verin6 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin7.node);
		local bx, by, bz = getWorldTranslation(self.verin6.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin7.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin7.node, x*-1, y*-1, z*-1, 0, 1, 0);
	end;
	if self.verin8 ~= nil and self.verin7 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin8.node);
		local bx, by, bz = getWorldTranslation(self.verin7.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin8.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin8.node, x*-1, y*-1, z*-1, 0, 1, 0);
	end;
	
	if self.verin4 ~= nil and self.tourelle2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin4.node);
		local bx, by, bz = getWorldTranslation(self.tourelle2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin4.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin4.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin4.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin4.tige, 0, 0, (distance-self.verin4.tigeDistance)*-1);
		end;
	end;
	
	if self.verin5 ~= nil and self.tourelle4 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin5.node);
		local bx, by, bz = getWorldTranslation(self.tourelle4.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin5.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin5.node, x*-1, y*-1, z*-1, 0, 0, 1);
		if self.verin5.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin5.tige, 0, 0, (distance-self.verin5.tigeDistance)*-1);
		end;
	end;

	if self.verin3 ~= nil and self.tourelle3 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin3.node);
		local bx, by, bz = getWorldTranslation(self.tourelle3.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin3.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin3.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin3.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin3.tige, 0, 0, (distance-self.verin3.tigeDistance)*-1);
		end;
	end;
	
		if self.verin9 ~= nil and self.verin7 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin9.node);
		local bx, by, bz = getWorldTranslation(self.verin7.pivotverin2);
		local x, y, z = worldDirectionToLocal(getParent(self.verin9.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin9.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin9.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin9.tige, 0, 0, (distance-self.verin9.tigeDistance)*-1);
		end;
	end;
	

	

	



end;
      


function scraper:draw()

if self.translationMax then
    g_currentMission:addExtraPrintText("Touche X: Mode deblai");
else
    g_currentMission:addExtraPrintText("Touche X: Mode remblai");
end;
g_currentMission:addExtraPrintText("KP_7/KP_4 benne haut/bas");
g_currentMission:addExtraPrintText("Touche B: ouvrir/fermer benne");

end;

function scraper:onLeave()
    if self.isClient then
   	    Utils.setEmittingState(self.exhaustParticleSystem, false)
        Utils.setEmittingState(self.exhaustParticleSyste, false)
        Utils.setEmittingState(self.exhaustParticleSyst, false)
    end;
end;   


function  scraper:onDeactivate()
    if self.isClient then
   	    Utils.setEmittingState(self.exhaustParticleSystem, false)
        Utils.setEmittingState(self.exhaustParticleSyste, false)
        Utils.setEmittingState(self.exhaustParticleSyst, false)

    end;

end;


